#include<bits/stdc++.h>
using namespace std;

int n,q,p,m;
int parent[1000007];
int sz[1000007],sum[1000007];
long long ans;

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>p>>m;
        parent[i]=p;
        sum[i]=sum[p];
        if(m>0){
            sz[i]=m;
            sum[i]+=m;
        }else{
            sz[i]=sz[parent[parent[i]]];
            sum[i]-=sz[parent[i]];
        }
        ans+=sum[i];
    }
    cout<<ans<<"\n";

    return 0;
}
